#include "Form.hpp"

#include <iostream>
#include <string>

Form::Form()
{
	std::cout << "Form()" << std::endl;
}

Form::Form(const Form& src)
{
	std::cout << "Form(Form)" << std::endl;
	*this = src;
}

Form::Form(const std::string& name, bool signd, int to_execute, int to_sign):
	_name(name),
	_signed(signd),
	_to_sign(to_sign),
	_to_execute(to_execute)
{
	std::cout << "Form(" << name << ", " << signd << ", " << to_execute << ", " << to_sign << ")" << std::endl;
	if (to_execute > 150 || to_sign < 1)
		throw GradeTooLowException();
	if (to_execute < 1 || to_sign < 1)
		throw GradeTooHighException();
}

Form::~Form()
{
	std::cout << "~Form()" << std::endl;
}

Form& Form::operator=(const Form& src)
{
	this->_signed = src._signed;
	this->_to_sign = src._to_sign;
	this->_to_execute = src._to_execute;

	return *this;
}

void Form::beSigned(const Bureaucrat &bureaucrat)
{
	if (this->_signed == false)
	{
		std::cout << bureaucrat.getName() << " couldn't sign " << this->_name << " because " << "the form is already sign" << std::endl;
		return;
	}
	if (bureaucrat.getGrade() > this->_to_sign)
		throw GradeTooLowException();
	this->_signed = true;
	std::cout << bureaucrat.getName() << " signed " << this->_name << std::endl;
}
